/**
 *	GPU_LIB_WIN32_SHOW_WINDOW
 *		- if defined, window used for creating OpenGL context is visible
 *		  (it contains image OpenGL 2.0 logo, inlined in the code)
 */
//#define GPU_LIB_WIN32_SHOW_WINDOW

/**
 *	bool Init_OpenGL()
 *		- initializes OpenGL. under linux uses GLUT, under windows uses custom driver
 *		- in case running under windows, there's option to display OpenGL window,
 *		  containing "OpenGL 2.0" logo (enabled using GPU_LIB_WIN32_SHOW_WINDOW #define)
 *		- returns true on success (or multiple initialization), false on failure
 */
bool Init_OpenGL();

/**
 *	bool Shutdown_OpenGL();
 *		- shuts down OpenGL, previously initialized by Init_OpenGL(), calls Free_OpenGL_Objects()
 *		  to delete all kinds of temporary objects library uses
 *		- returns true on success, false on failure
 *		- note for linux - there's no function to shut down GLUT, it's expected
 *		  to call this just before exitting as it has really no effect on OpenGL, it frees
 *		  OpenGL objects only
 */
bool Shutdown_OpenGL();
