
#include "image.h"
#include <stdio.h>

//
// TImage
//

#define ALIGN4(x) (x)

TImage::TImage(unsigned w, unsigned h):
    width(w), height(h), widthStep(ALIGN4(w)), reference(false)
{
    data = new char[widthStep * height];
}

TImage::TImage(unsigned w, unsigned h, unsigned ws, char * d):
    width(w), height(h), widthStep(ws), reference(true), data(d)
{   }


TImage::~TImage()
{
    if (data && !reference) delete [] data;
}

//
// Procedural interface
//

TImage * createImage(unsigned w, unsigned h)
{
    return new TImage(w, h);
}

TImage * createImageHeader(unsigned w, unsigned h, unsigned ws, char * data)
{
    return new TImage(w, h, ws, data);
}

void releaseImage(TImage ** image)
{
    delete *image;
    *image = 0;
}

// No OpenCV, so here is stupid resize code
// Nearest-neighbour
void resize(TImage * src, TImage * dst)
{
    ///printf("%dx%d->%dx%d\n", src->width, src->height, dst->width, dst->height);
    float xScale = float(src->width) / dst->width;
    float yScale = float(src->height) / dst->height;

    char * dRow = dst->data;
    char * sRow = src->data;
    int y = 0;

    while (dRow < dst->data + dst->height * dst->widthStep)
    {
        for (unsigned x = 0; x < dst->width; ++x)
        {
            dRow[x] = sRow[int(x * xScale)];
        }

        ++y;
        sRow = src->data + int(y * yScale) * src->widthStep;
        dRow += dst->widthStep;
    }
}

