//-----------------------------------------------------------------------------
// lrd_engine.h
// Naive implementation of LRD evaluation
// Roman Juranek, DCGM FIT BUT, Brno
// $Id: lrd_engine.h 157 2009-08-25 08:31:24Z ihavel $
//-----------------------------------------------------------------------------


#ifndef __SIMPLE_LRD_ENGINE_H__
#define __SIMPLE_LRD_ENGINE_H__

#include <aboninterface.h>
#include "image.h"

extern unsigned weakClassifiers;

/// Scan entire image with a classifier.
/// \param image Input intensity image (IPL_DEPTH_8U, single chanel)
/// \param classifier Classifier to evaluate
/// \param results Preallocated vector for results
/// \returns Number of detections
unsigned scanImage(TImage * image, TClassifier * classifier, abonDetection * results, abonDetection * results_end, int hStep, int vStep);

#endif

