#ifndef GL_WINDOW_H
#define GL_WINDOW_H

#include <aboninterface.h>

#include <cxcore.h>

class Window
{
private :
    abonImageData *abonImage;//image to display
    IplImage *cvImage;

    bool fullscreen;
    bool toggleFS;
    bool close;

    //callbacks
    static Window *window;
    static void onDisplay();
    static void onKeyboard(unsigned char key, int x, int y);
    static void onReshape(int w, int h);
public :
    void setSize(unsigned width, unsigned height);
    void setFullScreen();

    void show(abonImageData *image);
    void show(IplImage *image);

    void update();

    bool isClosed();

    void open();

    Window();
    ~Window() throw();
};

#endif
